#include "../BasicCompiler_Common/common.h"
#include "Opcode.h"

void FreeTempObject(int reg,CClass *pobj_c){
	if(!IsSafeReg(reg)) SetError(300,NULL,cp);

	////////////////////////////////////////////////
	// ZߒŗpꎞIuWFNgj
	// This|C^r14WX^ēn
	////////////////////////////////////////////////

	CMethod *method = pobj_c->GetDestructorMethod();
	if( method ){
		//mov rcx,reg
		op_mov_RR(REG_RCX,reg);

		//call DestructorProcAddr
		op_call( method->psi );
	}

	//mov rcx,reg
	op_mov_RR(REG_RCX,reg);

	//call free
	extern SUBINFO *pSub_free;
	op_call(pSub_free);
}

int CallOperatorProc(int idCalc,TYPEINFO *pBaseTypeInfo,int *type,LONG_PTR *index_stack,BOOL *bUseHeap,int &sp){
	//I[o[[hꂽIy[^֐Ăяo
	CClass *pobj_c;
	pobj_c=(CClass *)index_stack[sp-2];

	std::vector<SUBINFO *> subs;
	pobj_c->EnumMethod( idCalc, subs );
	if( subs.size() == 0 ){
		return 0;
	}


	//̐
	BOOL bTwoTerm=1;
	if(idCalc==CALC_AS) bTwoTerm=0;


	int i;
	BOOL bReturnTypeIsObject=1;
	TYPEINFO ReturnType={DEF_OBJECT,subs[0]->u.ReturnIndex};
	for(i=0;i<subs.size();i++){
		if(subs[i]->ReturnType!=DEF_OBJECT)
			bReturnTypeIsObject=0;
	}

	if(bReturnTypeIsObject==0){
		if(pBaseTypeInfo){
			if(pBaseTypeInfo->type==DEF_OBJECT){
				bReturnTypeIsObject=1;
				ReturnType.u.lpIndex=pBaseTypeInfo->u.lpIndex;
			}
		}
	}



	/////////////////////////////////////////////
	// I[o[[hp̃p[^ݒ
	/////////////////////////////////////////////

	PARAMETER_INFO *ppi = (PARAMETER_INFO *)HeapAlloc(hHeap,0,sizeof(PARAMETER_INFO)*3);
	int iParmNum=0;

	if(bTwoTerm){
		ppi[iParmNum].bArray=0;
		ppi[iParmNum].bByVal=0;
		ppi[iParmNum].name=0;
		ppi[iParmNum].type=type[sp-1];
		ppi[iParmNum].u.index=index_stack[sp-1];
		ppi[iParmNum].SubScripts[0]=-1;
		iParmNum++;
	}


	//I[o[[h
	char temporary[255];
	if(idCalc==CALC_EQUAL) lstrcpy(temporary,"==");
	else GetCalcName(idCalc,temporary);
	SUBINFO *psi;
	psi=OverloadSolution(temporary,subs,ppi,iParmNum,pBaseTypeInfo);


	if(!psi){
		HeapDefaultFree(ppi);
		return -1;
	}
	else{
		//I[o[[hĂȂAp[^vȂƂ
		if(iParmNum!=psi->ParmNum){
			HeapDefaultFree(ppi);
			return -1;
		}
	}

	for(i=0;i<iParmNum;i++){
		CheckDifferentType(
			psi->pParmInfo[i].type,
			psi->pParmInfo[i].u.index,
			ppi[i].type,
			ppi[i].u.index,
			"",
			i);
	}

	HeapDefaultFree(ppi);

	int right_side_size;
	if(type[sp-1]==DEF_OBJECT) right_side_size=PTR_SIZE;
	else right_side_size=GetTypeSize(type[sp-1],index_stack[sp-1]);

	if(bTwoTerm){
		if(psi->pParmInfo[1].type==DEF_OBJECT&&psi->pParmInfo[1].bByVal){
			//ꎞIuWFNg̓\bhŔj
			bUseHeap[sp-1]=0;
		}
	}


	if(psi->ReturnType==DEF_OBJECT){
		//////////////////////////////////////////////////////
		// ߂lɃIuWFNg CX^Xꍇ
		// ByRef _System_ReturnObject p[^p̈擾
		//////////////////////////////////////////////////////


		//////////////////////////////////////////////////////
		/////    WX^̃obNAbv
		{	BACKUP_REGISTER_RESOURCE
		//////////////////////////////////////////////////////

			int object_size = psi->u.Return_pobj_c->GetSize();

			//mov rcx,object_size
			op_mov_RV(sizeof(_int64),REG_RCX,object_size);

			//call calloc
			extern SUBINFO *pSub_calloc;
			op_call(pSub_calloc);

			//mov r13,rax
			op_mov_RR(REG_R13,REG_RAX);

		/////////////////////////////////////////////
		//////   WX^𕜌
			RESTORE_REGISTER_RESOURCE
		}////////////////////////////////////////////
	}


	int reg1,reg2;
	if(bTwoTerm){
		//E̍ȉꍇj
		SetOneTermToReg_Whole64Calc(type[sp-1],&reg2);
		pobj_reg->UnlockReg();
	}

	//̍
	SetOneTermToReg_Whole64Calc(DEF_INT64,&reg1);
	pobj_reg->UnlockReg();

	//q[vpɑޔ
	if(bUseHeap[sp-1]){
		//mov qword ptr[rsp+offset],reg2     X^bNt[𗘗p
		pobj_sf->push(reg2);
	}
	if(bUseHeap[sp-2]){
		//mov qword ptr[rsp+offset],reg1     X^bNt[𗘗p
		pobj_sf->push(reg1);
	}



	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		if(reg1==REG_RDX||reg1==REG_R8){
			//mov r14,reg1
			op_mov_RR(REG_R14,reg1);
			reg1=REG_R14;
		}


		if(bTwoTerm){
			if(psi->ReturnType==DEF_OBJECT){
				//mov r8,reg2
				op_mov_RR(REG_R8,reg2);
			}
			else{
				//mov rdx,reg2
				op_mov_RR(REG_RDX,reg2);
			}
		}

		if(psi->ReturnType==DEF_OBJECT){
			//mov rdx,r13
			op_mov_RR(REG_RDX,REG_R13);
		}

		//mov rcx,reg1
		op_mov_RR(REG_RCX,reg1);

		//call operator_proc
		op_call(psi);

		if(psi->ReturnType!=-1){
			//߂lꎞIɑޔ

			//mov r13,rax
			op_mov_RR(REG_R13,REG_RAX);
		}


	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////



	if(bUseHeap[sp-2]||bUseHeap[sp-1]){

		//////////////////////////////////////////////////////
		/////    WX^̃obNAbv
		{	BACKUP_REGISTER_RESOURCE
		//////////////////////////////////////////////////////

			if(bUseHeap[sp-2]){
				//mov r14,qword ptr[rsp+offset]     X^bNt[𗘗p
				pobj_sf->pop(REG_R14);

				FreeTempObject(REG_R14,(CClass *)index_stack[sp-2]);
			}
			if(bUseHeap[sp-1]){
				//mov r14,qword ptr[rsp+offset]     X^bNt[𗘗p
				pobj_sf->pop(REG_R14);

				FreeTempObject(REG_R14,(CClass *)index_stack[sp-1]);
			}

		/////////////////////////////////////////////
		//////   WX^𕜌
			RESTORE_REGISTER_RESOURCE
		}////////////////////////////////////////////
	}

	if(psi->ReturnType!=-1){
		//߂lreg1ɃZbg
		reg1=pobj_reg->LockReg();

		//mov reg1,r13
		op_mov_RR(reg1,REG_R13);
	}

	sp--;
	type[sp-1]=psi->ReturnType;
	index_stack[sp-1]=psi->u.ReturnIndex;

	if(psi->ReturnType==DEF_OBJECT){
		//Object^߂Ƃ̓q[v̈ɃCX^Xi[Ă
		//freeKv
		bUseHeap[sp-1]=1;
	}
	else bUseHeap[sp-1]=0;

	return 1;
}

void CallCastOperatorProc(int reg,int &CalcType,LONG_PTR &lpCalcIndex,BOOL bCalcUseHeap,int ToType,LONG_PTR lpToIndex){
	int type[10];
	LONG_PTR index_stack[10];
	BOOL array_bUseHeap[10];
	int sp=2;
	int iRet;


	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		//regꍀڂƂăbN
		pobj_reg=new CRegister(reg);
		pobj_reg->LockReg();

		if(bCalcUseHeap){
			//̃CX^X݂|x
			SetError(-105,NULL,cp);
		}

		//
		type[0]=CalcType;
		index_stack[0]=lpCalcIndex;
		array_bUseHeap[0]=0;
		type[1]=ToType;
		index_stack[1]=lpToIndex;
		array_bUseHeap[1]=0;

		TYPEINFO BaseTypeInfo={ToType,lpToIndex};

		iRet=CallOperatorProc(CALC_AS,&BaseTypeInfo,type,index_stack,array_bUseHeap,sp);

		pobj_reg->UnlockReg();

	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////


	if(iRet==1){
		//Ƃ
		CalcType=type[0];
		lpCalcIndex=index_stack[0];
		return;
	}
	else if(iRet==-1){
		//G[sꂽƂ
		return;
	}

	//G[𔭍s
	SetError(-1,"LXgZqI[o[[hĂ܂B",cp);
}

//CfNTigetterjĂяo
void CallIndexerGetterProc(int reg,CClass *pobj_Class,char *ObjectName,char *Parameter,TYPEINFO &RetTypeInfo){

	std::vector<SUBINFO *> subs;
	pobj_Class->EnumMethod( CALC_ARRAY_GET, subs );
	if( subs.size() == 0 ){
		return;
	}

	//////////////////////////////////////////////////////
	/////    WX^̃obNAbv
	{	BACKUP_REGISTER_RESOURCE
	//////////////////////////////////////////////////////

		Opcode_CallProc(Parameter,subs[0],0,ObjectName,DEF_OBJECT);
		RetTypeInfo.type = subs[0]->ReturnType;
		RetTypeInfo.u.lpIndex = subs[0]->u.ReturnIndex;

		//mov reg,rax
		op_mov_RR(reg,REG_RAX);

	/////////////////////////////////////////////
	//////   WX^𕜌
		RESTORE_REGISTER_RESOURCE
	}////////////////////////////////////////////

}
